package net.rhuanrocha.mdbcallingejbclient.ejb;

import net.rhuanrocha.mdbcallingejb.ejb.Remote;

import javax.annotation.Resource;

import javax.ejb.Stateless;
import javax.inject.Inject;
import javax.jms.JMSConnectionFactory;
import javax.jms.JMSContext;
import javax.jms.Queue;

@Stateless
public class TestEjb {

    private boolean ROLLBACK = false;

    @Inject
    @JMSConnectionFactory("java:jboss/DefaultJMSConnectionFactory")
    private JMSContext jmsContext;


    @Resource(mappedName = "java:/jms/queue/TestQueue")
    private Queue queue;

    @Resource(lookup = "ejb:/mdbcallingejb-1.0-SNAPSHOT/TestEjb!net.rhuanrocha.mdbcallingejb.ejb.Remote")
    private Remote remote;

    @Resource(lookup = "ejb:/mdbcallingejb-1.0-SNAPSHOT/TestEjbStateful!net.rhuanrocha.mdbcallingejb.ejb.Remote?stateful")
    private Remote remoteStateful;

    public void test(String text){

        jmsContext.createProducer().send(queue,text);

        remote.test(text);

        if(ROLLBACK){
            throw new RuntimeException();
        }


    }

    public void testStateful(String text){

        jmsContext.createProducer().send(queue,text);

        remoteStateful.test(text);

        if(ROLLBACK){
            throw new RuntimeException();
        }


    }

}
