package net.rhuanrocha.mdbcallingejbclient.mdb;

import net.rhuanrocha.mdbcallingejbclient.ejb.TestEjb;

import javax.ejb.ActivationConfigProperty;
import javax.ejb.MessageDriven;
import javax.inject.Inject;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.ws.rs.core.Response;
import java.util.Optional;
import java.util.logging.Logger;


@MessageDriven(activationConfig = {
        @ActivationConfigProperty(propertyName = "destinationLookup",
                propertyValue = "java:/jms/queue/TestQueue"),
        @ActivationConfigProperty(propertyName = "destinationType",
                propertyValue = "javax.jms.Queue")
})
public class MDB implements MessageListener {

    private static Logger logger = Logger.getLogger(MDB.class.getName());

    @Inject
    private TestEjb testEjb;

    @Override
    public void onMessage(Message message) {

        logger.info("Running MDB....");

        try {
            testEjb.testStateful(message.getBody(String.class));
        } catch (JMSException e) {
            logger.severe(e.getMessage());
        }

        logger.info("Ending MDB....");

    }
}
